//#include "osa.h"

#ifdef WIN32 
#include <mysql.h>
#else
#include "/usr/local/mysql/include/mysql/mysql.h"
#include "/usr/local/mysql/include/mysql/mysqld_error.h"
#include "/usr/local/mysql/include/mysql/errmsg.h"
#include <stdio.h>
#include <sys/time.h>
#endif

static struct timeval _tstart, _tend;
static struct timezone tz;
double t_temp;
void tstart(void)
{
	gettimeofday(&_tstart, &tz);
}
void tend(void)
{
	gettimeofday(&_tend,&tz);
}
double tval()
{
	double t1, t2;
	t1 =  (double)_tstart.tv_sec + (double)_tstart.tv_usec/(1000*1000);
	t2 =  (double)_tend.tv_sec + (double)_tend.tv_usec/(1000*1000);
	return t2-t1;
}

//int test_mysql_2(void)
int main(int argc, char** argv)
{
    time_t t0, t1,t2,t3;
    MYSQL mysql;
    MYSQL_RES *result;
    MYSQL_ROW row; 
    int n, d, id;
    char sql[200];

 while(1) {
    if( mysql_init(&mysql) == NULL )
    {
        printf("failed to mysql_init.\r\n");
        return 0;
    }

    if( !mysql_real_connect(&mysql, 
							"", "root", "", "moodle",
                            //"10.50.49.12", "george", "rss123", "lsdb",
			                0, //port
							NULL, 
							0) ) 
    {
        printf(" mysql_real_connect() failed: %s\n", mysql_error(&mysql));
        //return 0;
        sleep(1);
        continue;
    }


	tstart();
	//sprintf(sql,"select vod_service_id,vod_content_id,vod_content_key,vod_asset_id,vod_key_id,permit_start_date,permit_end_date from vod_content order by vod_key_id limit  %d, 1000", i);
	sprintf(sql,"select id from mdl_user_1014 limit 1");
	if ( 0!=mysql_real_query(&mysql, sql, strlen(sql)) )
    	{
		printf("mysql_real_query failed: %s\n", mysql_error(&mysql));
		sleep(1);
//		return 0;   
continue;
	}

	//t1 = time(NULL);
    	//printf(" spent %d for mysql_real_query.\r\n", (int32_t)(t1-t0));
    	tend();
    	printf(" spent %f for mysql_real_query.\r\n", tval());
    
       tstart();
    	   if ( (result = mysql_store_result(&mysql))==NULL )
    	   {
		printf("mysql_store_result failed: %s\n", mysql_error(&mysql));
		return 0;   
	   }

    tend();
    	printf(" spent %f for mysql_store_result.\r\n", tval());
    
    tstart();
    printf("fetching...\r\n");
    n = 0;
    while ( (row = mysql_fetch_row(result)) )
    {
        id = atoi(row[0]);
        printf("id= %d\n",id);
        n++;
    }
    tend();
    printf(" spent %f for %d rows.\r\n", tval(), n);

    if (0!=mysql_errno(&mysql))
    {
        printf("mysql_fetch_row failed: %s\n", mysql_error(&mysql));
    }
    
    
    sprintf(sql,"update mdl_user_1014 set msn='abc@msn.com' where id = %d",id);
	if ( 0!=mysql_real_query(&mysql, sql, strlen(sql)) )
    	{
		printf("mysql_real_query failed: %s\n", mysql_error(&mysql));
		return 0;   
	}

    (void)mysql_free_result(result);

    
    (void)mysql_close(&mysql);
    
        sleep(1);
 }
    return 0;
}
